#ifndef __GTK_HST2D_H__
#define __GTK_HST2D_H__

#include <gtk-hst/gtkhistogram.h>
#include <gtk-hst/histogram2d.h>

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define GTK_TYPE_HST2D	(gtk_hst2d_get_type())
#define GTK_HST2D(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), GTK_TYPE_HST2D, GtkHst2D)
#define GTK_HST2D_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), GTK_TYPE_HST2D, GtkHst2D const)
#define GTK_HST2D_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), GTK_TYPE_HST2D, GtkHst2DClass)
#define GTK_IS_HST2D(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gtk_hst2d_get_type ())

#define GTK_HST2D_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), GTK_TYPE_HST2D, GtkHst2DClass)

typedef enum {
    HST_COLOR_2D_BW,
    HST_COLOR_2D_WB,
    HST_COLOR_2D_RED,
    HST_COLOR_2D_GREEN,
    HST_COLOR_2D_BLUE,
    HST_COLOR_2D_THERMAL,
    HST_COLOR_2D_LAST
} GtkHstColorScheme;
GType gtk_hst_color_scheme_get_type (void);
#define GTK_TYPE_HST_COLOR_SCHEME (gtk_hst_color_scheme_get_type())


/*
 * Main object structure
 */
typedef struct _GtkHst2D GtkHst2D;
struct _GtkHst2D {
    GtkHst1D __parent__;
    GtkHstColorScheme ctype;
    int       ncol;
    GdkColor *colorlst;

    gboolean squared;
    
    /* Data stored in order */
    int ntot;
    int nindx;
    int bsiz;

    gint      *dindex,*dkey;
};

/*
 * Class definition
 */
typedef struct _GtkHst2DClass GtkHst2DClass;
struct _GtkHst2DClass {
	GtkHst1DClass __parent__;
};


/*
 * Public methods
 */
GType	gtk_hst2d_get_type	(void);
GtkWidget *gtk_hst2d_new  (HstHistogram2D *f2d);
void       gtk_hst2d_set_squared(GtkHst2D *h2d, gboolean squared);
G_END_DECLS
#endif
