#ifndef __HISTOGRAM2D_H__
#define __HISTOGRAM2D_H__

#include <gtk-hst/function2d.h>
#include <gtk-hst/stats.h>

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define HST_TYPE_HISTOGRAM2D	   (hst_histogram2d_get_type())
#define HST_HISTOGRAM2D(obj)	   G_TYPE_CHECK_INSTANCE_CAST((obj), HST_TYPE_HISTOGRAM2D, HstHistogram2D)
#define HST_HISTOGRAM2D_CONST(obj)   G_TYPE_CHECK_INSTANCE_CAST((obj), HST_TYPE_HISTOGRAM2D, HstHistogram2D const)
#define HST_HISTOGRAM2D_CLASS(klass) G_TYPE_CHECK_CLASS_CAST((klass), HST_TYPE_HISTOGRAM2D, HstHistogram2DClass)
#define HST_IS_HISTOGRAM2D(obj)	   G_TYPE_CHECK_INSTANCE_TYPE((obj), HST_TYPE_HISTOGRAM2D)

#define HST_HISTOGRAM2D_GET_CLASS(obj) G_TYPE_INSTANCE_GET_CLASS((obj), HST_TYPE_HISTOGRAM2D, HstHistogram2DClass)

/*
 * Main object structure
 */
typedef struct _HstHistogram2D HstHistogram2D;

struct _HstHistogram2D {
    HstFunction2D __parent__;
    double   *y;      /* array for bin contents */
    HstStats *stat;   /* statistics */

    int    owner;     /* flag saying if we own the array */
    double vmin; 
    double vmax; 
};

/*
 * Class definition
 */
typedef struct _HstHistogram2DClass HstHistogram2DClass;
struct _HstHistogram2DClass {
    HstFunction2DClass __parent__;

    void (*fill)(HstHistogram2D *, double x, double y, double w);
    void (*reset)(HstHistogram2D *);

    /* signals */
    void (*changed)(HstHistogram2D *);
};


/*
 * Public methods
 */
GType	        hst_histogram2d_get_type	(void);
HstHistogram2D *hst_histogram2d_new(int nx, double xmin, double xmax,
				    int ny, double ymin, double ymax,
				    gdouble *ptr);
void 	        hst_histogram2d_fill (HstHistogram2D * h2d,
				      double x,
				      double y,
				      double w);
int             hst_histogram2d_get_stats(HstHistogram2D *h2d, HstStats *s);
void            hst_histogram2d_reset(HstHistogram2D *h2d);
G_END_DECLS

#endif
